<!--
Copyright 2021 IRT Saint Exupéry, https://www.irt-saintexupery.com

This work is licensed under the Creative Commons Attribution-ShareAlike 4.0
International License. To view a copy of this license, visit
http://creativecommons.org/licenses/by-sa/4.0/ or send a letter to Creative
Commons, PO Box 1866, Mountain View, CA 94042, USA.
-->

<!--
Changelog titles are:
- Added: for new features.
- Changed: for changes in existing functionality.
- Deprecated: for soon-to-be removed features.
- Removed: for now removed features.
- Fixed: for any bug fixes.
- Security: in case of vulnerabilities.
-->

# Changelog

All notable changes of this project will be documented here.

The format is based on
[Keep a Changelog](https://keepachangelog.com/en/1.0.0)
and this project adheres to
[Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## Develop

### Added

- The U-MDO formulation [PCE][gemseo_umdo.formulations.pce.PCE] creates a polynomial chaos expansion (PCE)
  over the uncertain space at each iteration of the optimization loop and uses the coefficients of the PCE
  to estimate the following statistics: `Mean`, `StandardDeviation`, `Margin` and `Variance`.
- The U-MDO formulations
  [Sampling][gemseo_umdo.formulations.sampling.Sampling] and
  [SequentialSampling][gemseo_umdo.formulations.sequential_sampling.SequentialSampling]
  have an option `samples_directory_path`
  to save the samples at each iteration of the algorithm chosen for the execution of the
  [UDOEScenario][gemseo_umdo.scenarios.udoe_scenario.UDOEScenario]
  or [UMDOScenario][gemseo_umdo.scenarios.umdo_scenario.UMDOScenario].
- The U-MDO formulation [SequentialSampling][gemseo_umdo.formulations.sequential_sampling.SequentialSampling]
  has an option `estimate_statistics_iteratively` (default: `True`)
  to compute the statistics iteratively
  and so do not store the samples in a `Database`.
- The dictionary argument `uncertain_design_variables` of
  [UDOEScenario][gemseo_umdo.scenarios.udoe_scenario.UDOEScenario]
  and [UMDOScenario][gemseo_umdo.scenarios.umdo_scenario.UMDOScenario]
  can now accept values such as `("+", "u")` and `("*", "u")`
  to noise the corresponding key `x` as `x = dv_x + u` and `x = dv_x * (1 + u)`
  where `x` is a discipline input made uncertain by the random variable `u`.
- [AdditiveNoiser][gemseo_umdo.disciplines.additive_noiser.AdditiveNoiser]
  and
  [MultiplicativeNoiser][gemseo_umdo.disciplines.multiplicative_noiser.MultiplicativeNoiser]
  are disciplines to noise a design variable $x$ as $X=x+U$ and $X=x(1+U)$ respectively
  where $U$ is a random variable.
  [BaseNoiser][gemseo_umdo.disciplines.base_noiser.BaseNoiser]
  can be used to create other noising disciplines
  and a specific
  [NoiserFactory][gemseo_umdo.disciplines.noiser_factory.NoiserFactory]
  is available.
- [ControlVariate][gemseo_umdo.formulations.control_variate.ControlVariate],
  a new [BaseUMDOFormulation][gemseo_umdo.base_umdo_formulation.base_umdo_formulation.BaseUMDOFormulation]
  estimating the statistics with a control variate technique based on Taylor polynomials.

### Changed

- `gemseo_umdo.scenarios._uscenario._UScenario` renamed to `gemseo_umdo.scenarios.base_u_scenario.BaseUScenario`.
- API CHANGE: `gemseo_umdo.statistics.mlmc.pilots.pilot.MLMCPilot` renamed to `gemseo_umdo.statistics.mlmc.pilots.base_mlmc_pilot.BaseMLMCPilot`.
- API CHANGE: `gemseo_umdo.statistics.mlmc_mlcv.pilots.pilot.MLMCMLCVPilot` renamed to `gemseo_umdo.statistics.mlmc_mlcv.pilots.base_mlmc_mlcv_pilot.BaseMLMCMLCVPilot`.
- API CHANGE: `gemseo_umdo.statistics.pilot.Pilot` renamed to `gemseo_umdo.statistics.base_pilot.BasePilot`.
- API CHANGE: `gemseo_umdo.formulations.formulation.UMDOFormulation` renamed to `gemseo_umdo.formulations.base_umdo_formulation.BaseUMDOFormulation`.
- API CHANGE: `gemseo_umdo.formulations.statistics` is now a protected package.
- API CHANGE: `gemseo_umdo.formulations.functions` is now a protected package.
- The [BeamConstraints][gemseo_umdo.use_cases.beam_model.constraints.BeamConstraints] discipline
  computed outputs of the form `a/(b+eps)` where `eps` was used to avoid division by zero.
  Now,
  this discipline computes outputs of the form `b/a`
  as `a` is never zero.

### Fixed

- The U-MDO formulation [Sampling][gemseo_umdo.formulations.sampling.Sampling]
  works properly when the option `estimate_statistics_iteratively`  is `True`
  and the DOE option `n_processes` is greater than 1.
- The docstring of the `uncertain_design_variables` argument of
  [UDOEScenario][gemseo_umdo.scenarios.udoe_scenario.UDOEScenario]
  and [UMDOScenario][gemseo_umdo.scenarios.umdo_scenario.UMDOScenario]
  explains that specifying a value such as `"{} + u"` at key `"x"`
  assumes that both the uncertain design variable `"x"`
  and the uncertain variable `"u"` are scalar variables.
- The discipline transforming the design variables into uncertain design variables
  is placed before the user's disciplines;
  by doing so,
  the uncertain design variables can be propagated
  through the multidisciplinary process
  even with MDO formulations that do not ensure the satisfaction of couplings,
  such as [DisciplinaryOpt][gemseo.formulations.disciplinary_opt.DisciplinaryOpt].

## Version 2.0.1 (January 2024)

### Fixed

- The U-MDO formulations handle the finite-difference approximation of derivatives.

## Version 2.0.0 (December 2023)

### Added

- Support for Python 3.11.
- A web documentation.
- The heat equation problem (
  [HeatEquationConfiguration][gemseo_umdo.use_cases.heat_equation.configuration.HeatEquationConfiguration],
  [HeatEquationDiscipline][gemseo_umdo.use_cases.heat_equation.discipline.HeatEquation],
  [HeatEquationModel][gemseo_umdo.use_cases.heat_equation.model.HeatEquationModel]
  and [HeatEquationUncertainSpace][gemseo_umdo.use_cases.heat_equation.uncertain_space.HeatEquationUncertainSpace])
  to illustrate the algorithms [MLMC][gemseo_umdo.statistics.multilevel.mlmc.mlmc.MLMC]
  and [MLMCMLCV][gemseo_umdo.statistics.multilevel.mlmc_mlcv.mlmc_mlcv.MLMCMLCV].
- The [MLMC][gemseo_umdo.statistics.multilevel.mlmc.mlmc.MLMC] and
  the [MLMCMLCV][gemseo_umdo.statistics.multilevel.mlmc_mlcv.mlmc_mlcv.MLMCMLCV]
  algorithms to estimate a statistic of the output of a function
  whose input is random.
- The [MonteCarloSampler][gemseo_umdo.monte_carlo_sampler.MonteCarloSampler]
  to sample vectorized functions.
- [UncertainCouplingGraph][gemseo_umdo.visualizations.uncertain_coupling_graph.UncertainCouplingGraph]
  has a new option `save` (default: `True`).
- The U-MDO formulation [Sampling][gemseo_umdo.formulations.sampling.Sampling]
  has an option `estimate_statistics_iteratively` (default: `True`)
  to compute the statistics iteratively
  and so do not store the samples in a `Database`.
- The package `gemseo_umdo.formulations.functions` contains the `MDOFunction`s
  used by a [UMDOFormulation][gemseo_umdo.formulations.formulation.UMDOFormulation]
  to compute the statistics of the objective, constraints and observables.
- The logs of the [UDOEScenario][gemseo_umdo.scenarios.udoe_scenario.UDOEScenario]
  and [UMDOScenario][gemseo_umdo.scenarios.umdo_scenario.UMDOScenario]
  include the uncertain space.

### Changed

- Setting the argument `n_samples`
  of the U-MDO formulation [Sampling][gemseo_umdo.formulations.sampling.Sampling]
  is mandatory for many DOE algorithms
  but optional in the case where
  the DOE algorithm does not consider a `n_samples` argument to generate the samples.
- The estimator of the [Variance][gemseo_umdo.formulations.statistics.sampling.variance.Variance]
  used by the U-MDO formulation [Sampling][gemseo_umdo.formulations.sampling.Sampling]
  with `estimate_statistics_iteratively=False` is now unbiased.
- API changes:
  - The options of the statistics estimators
    are now set at instantiation instead of execution.
  - `gemseo_umdo.estimators` has been renamed to `gemseo_umdo.formulations.statistics`.
- The log of the statistics no longer includes design variables and uncertain inputs
  (e.g. `E[y(x; u)]`),
  but only uncertain output  (e.g. `E[y]`) to avoid display problems in large dimensions.

### Fixed

- The [UDOEScenario][gemseo_umdo.scenarios.udoe_scenario.UDOEScenario]
  and [UMDOScenario][gemseo_umdo.scenarios.umdo_scenario.UMDOScenario]
  maximize the statistic of the objective
  when the argument `maximize_objective` is set to `True`.
- The log of the objective and constraint is now consistent
  with the arguments `maximize_objective` and `constraint_name`.

### Removed

- Support for Python 3.8.

## Version 1.1.1 (October 2023)

### Fixed

- One test was not compatible with GEMSEO 5.1+.

## Version 1.1.0 (June 2023)

### Added

- The beam problem ([Beam][gemseo_umdo.use_cases.beam_model.discipline.Beam],
  [BeamConstraints][gemseo_umdo.use_cases.beam_model.constraints.BeamConstraints],
  [BeamUncertainSpace][gemseo_umdo.use_cases.beam_model.uncertain_space.BeamUncertainSpace]
  and [BeamDesignSpace][gemseo_umdo.use_cases.beam_model.design_space.BeamDesignSpace]
  to benchmark robust optimization algorithms.
- [TaylorPolynomial][gemseo_umdo.formulations.taylor_polynomial.TaylorPolynomial],
  a new [UMDOFormulation][gemseo_umdo.formulations.formulation.UMDOFormulation]
  estimating the statistics with Taylor polynomials.
- [SequentialSampling][gemseo_umdo.formulations.sequential_sampling.SequentialSampling],
  a new [UMDOFormulation][gemseo_umdo.formulations.formulation.UMDOFormulation]
  estimating the statistics with sequential sampling.
- [UncertainCouplingGraph][gemseo_umdo.visualizations.uncertain_coupling_graph.UncertainCouplingGraph]
  to visualize the dispersion of the coupling variables.
- [SobolGraph][gemseo_umdo.visualizations.sobol_graph.SobolGraph]
  to visualize the first-, second- and total-order Sobol' indices.
- The set of [SpringMassModel][gemseo_umdo.use_cases.spring_mass_model.model.SpringMassModel],
  [SpringMassDiscipline][gemseo_umdo.use_cases.spring_mass_model.discipline.SpringMassDiscipline]
  and [SpringMassUncertainSpace][gemseo_umdo.use_cases.spring_mass_model.uncertain_space.SpringMassUncertainSpace]
  is a use case based on a spring-mass system.

### Fixed

- The `_UScenario` no longer changes the list of disciplines passed by the user.

## Version 1.0.1 (January 2023)

### Changed

- API change: the argument `statistic_estimation_options`
  of [UMDOFormulation][gemseo_umdo.formulations.formulation.UMDOFormulation]
  has been renamed to `statistic_estimation_parameters`.
- API change: `UMDOFormulation._processed_functions` replaces `Sampling.processed_functions`.

### Version 1.0.0 (July 2022)

First release.
